<template>
  <div>
    <base-dialog
        :show="!!error"
        title="An error occurred!"
        @close="handleError"
    >
      <p>{{ error }}</p>
    </base-dialog>
    <section>
      <base-card>
        <div v-if="isLoading">
          <base-spinner></base-spinner>
        </div>
        <div v-else-if="!isLoading && profiles.length > 0">
          <ul>
            <user-profile
                v-for="item in profiles.length"
                :key="profiles[item - 1]['id']"
                :id="profiles[item - 1]['id']"
                :first-name="profiles[item - 1]['firstName']"
                :last-name="profiles[item - 1]['lastName']"
                :email="profiles[item - 1]['email']"
                :address="profiles[item - 1]['address']"
                :birth-date="profiles[item - 1]['birthDate']"
                :picture-url="profiles[item - 1]['picture']['large']"
                :register-date="profiles[item - 1]['registerDate']"
                :register-time="profiles[item - 1]['registerTime']"
            >
            </user-profile>
          </ul>
          <div class="center">
            <base-button @click.prevent="loadProfiles" mode="outline"
            >Load More Profiles</base-button
            >
          </div>
        </div>
      </base-card>
    </section>
  </div>
</template>

<script setup>
import UserProfile from "../components/UserProfile.vue";
import { ref, onMounted } from "vue";
import { useStore } from "vuex";

const isLoading = ref(false);
const error = ref(null);
const profiles = ref([]);

const store = useStore();

async function loadProfiles() {
  if (!profiles.value.length > 0) {
    isLoading.value = true;
  }
  try {
    await store.dispatch("addUsers", profiles.value.length);
  } catch (error) {
    error.value = error.message || "Something went wrong";
  }
  isLoading.value = false;
}

function handleError() {
  error.value = null;
}

onMounted(async function () {
  if (!store.getters.isOpened) {
    await store.dispatch('isOpen');
    await loadProfiles();
  }
  profiles.value = store.getters.users;
});
</script>